class MenuDSL
    
    attr_accessor :titul, :ingest, :plato, :porcent, :name
    
    def initialize(name,&block)
        self.name = name
        self.titul = []
        self.ingest = []
        self.plato = []
        self.porcent = []
        
        if block_given?
            if block.arity == 1
                yield self
            else
                instance_eval &block
            end
        end
    end
   
    def to_s
    
        output = "#{name}\n"
        titul.each do |title|
            output << "#{title}"
            output << "\n#{'=' * title.size}\n"
        end
        
        ingest.each do |ing|
            output << "#{ing}"
        end

        plato.each_with_index do |plat, index|
            output << "\n#{index + 1})#{plat}"
        end
        
        output << "\nV.C.T | % "
        
        porcent.each do |porcentaje|
            output << "#{porcentaje}"
        end
        output << "\n"
        
        output
    end
    
    def titulo(text, options = {})
        title = text
        
        titul << title
    end
    
    def porcentajes(text,options = {})
        porcentaje = text
        porcentaje << "#{options[:vct]} kcal | " if options[:vct]
        porcentaje << "#{options[:proteinas]}% - " if options[:proteinas]
        porcentaje << "#{options[:grasas]}% - " if options[:grasas]
        porcentaje << "#{options[:hidratos]}%" if options[:hidratos]
        
        porcent << porcentaje
    end
    
    def ingesta(text, options = {})
        ing = text
        ing << "#{options[:min]} -" if options[:min]
        ing << " #{options[:max]} %" if options[:max]
        
        ingest << ing
    end
    
    def platos(text, options = {})
        plat = text
        plat << "#{options[:description]}, " if options[:description]
        plat << "#{options[:porcion]}, " if options[:porcion]
        plat << "#{options[:gramos]}" if options[:gramos]
        
        plato << plat
    end
end